package esi.ew.report.RP002;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.plw.util.Converter;

import esi.ew.report.common.JDBCUtil;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM_STATUS;

public class RP002Generator {
	
	private String ls_className = "RP002Generator";
    private JDBCUtil DBConn;
	private List<RP002Result> io_RPRL;
	public static final int MODIFY_STATUS = 10; //modify
	public static final int NEW_STATUS = 20;//new
	public static final int COMPLETE_STATUS = 30;//completeExamItemNo
	public static final int DISABLE_STATUS = 40;//disableExamItemNo

    public RP002Generator() throws ClassNotFoundException, SQLException {
		DBConn = new JDBCUtil();
	}
    
//	จำนวนข้อสอบในชุดวิชา
	public Integer GetTotalExamItemBySubjectID(Integer ai_subjectID) throws SQLException{
		String methodName = "GetTotalExamItemBySubjectID";
		Integer li_examItemNo = 0;
		if(ai_subjectID < 0){
			return 0;
		}
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("ISNULL(COUNT(EI.ExamItemID),-1) totalExamItemNo ");
		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_subjectID != null){
			sb_SQLCommand.append("AND EI.EI_SubjectID  = " + ai_subjectID + " ");
		}
		String ls_SQLCommand = sb_SQLCommand.toString();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : " + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		if (lo_Result.next()) {
			
			li_examItemNo = lo_Result.getInt("totalExamItemNo");
		}
		
		return li_examItemNo;
	}
	
	public String GenSQL(List<Integer> ao_subjectIDList) {

		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT ");
		sb_SQLCommand.append("SJ.SJ_Code subjectCode ,SJ.SJ_SubjectPrintedName subjectName,UN.UN_Order unit,ST.ST_Order section,  ");
		
		sb_SQLCommand.append("(");
			sb_SQLCommand.append(" CASE WHEN  EI.EI_LastExamStatusCompleteTime IS NOT NULL  ");
			sb_SQLCommand.append(" AND EI.EI_ExamStatus IN ( ");
			sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + ","
					+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue()
					+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
			sb_SQLCommand.append(" ) THEN " + MODIFY_STATUS + " WHEN  EI.EI_LastExamStatusCompleteTime IS NULL ");
			
			sb_SQLCommand.append(" AND EI.EI_ExamStatus IN ( ");
			sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_NEW.getValue() + ","
					+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue()
					+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue() + ","
					+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
			sb_SQLCommand.append(" ) THEN " + NEW_STATUS + " WHEN  EI.EI_ExamStatus IN ( ");
			
			sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_READY.getValue() + " ) THEN " + COMPLETE_STATUS + " WHEN  EI.EI_ExamStatus IN ( ");
			sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_DISABLE.getValue() + " ) THEN " + DISABLE_STATUS + " ELSE 0 END ");
		sb_SQLCommand.append(") examStatus, ");

		sb_SQLCommand.append("COUNT((CASE WHEN  EI.EI_LastExamStatusCompleteTime IS NOT NULL AND EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue()
				+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
		sb_SQLCommand.append(") THEN " + MODIFY_STATUS + " WHEN  EI.EI_LastExamStatusCompleteTime IS NULL ");
		sb_SQLCommand.append(" AND EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_NEW.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue()
				+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
		sb_SQLCommand.append(" ) THEN " + NEW_STATUS + " WHEN  EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_READY.getValue() + " ) THEN " + COMPLETE_STATUS
				+ " WHEN  EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(
				TYPE_EXAM_STATUS.STATUS_EXAM_DISABLE.getValue() + " ) THEN " + DISABLE_STATUS + " ELSE 0 END )) ");
		sb_SQLCommand.append("examStatusCount ");

		sb_SQLCommand.append("FROM ExamItem EI ");
		sb_SQLCommand.append("JOIN Subject SJ ON EI.EI_SubjectID = SJ.SubjectID ");
		sb_SQLCommand.append("LEFT JOIN Unit UN ON EI.EI_UnitID = UN.UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section  ST ON EI.EI_SectionID = ST.SectionID ");

		sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");

//		if (ao_subjectID != null) {
//			sb_SQLCommand.append("AND EI.EI_SubjectID  = " + ao_subjectID + " ");
//		}
		
		if(ao_subjectIDList != null){
			sb_SQLCommand.append("AND SJ.SubjectID IN (");
			int i = 0;
			for(Integer li_subjectID : ao_subjectIDList){
				if( i > 0){
					sb_SQLCommand.append(",");
				}
				sb_SQLCommand.append(li_subjectID);
				i++;
			}			
			sb_SQLCommand.append(") ");
			
		}
		sb_SQLCommand.append("GROUP BY SJ.SJ_Code ,SJ.SJ_SubjectPrintedName,UN.UN_Order,ST.ST_Order, ");
		sb_SQLCommand.append(" (CASE WHEN  EI.EI_LastExamStatusCompleteTime IS NOT NULL AND EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue()
				+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
		sb_SQLCommand.append(" ) THEN " + MODIFY_STATUS + " WHEN  EI.EI_LastExamStatusCompleteTime IS NULL ");
		sb_SQLCommand.append(" AND EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_NEW.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue() + "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue()
				+ "," + TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue() + ","
				+ TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue());
		sb_SQLCommand.append(" ) THEN " + NEW_STATUS + " WHEN  EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(TYPE_EXAM_STATUS.STATUS_EXAM_READY.getValue() + " ) THEN " + COMPLETE_STATUS
				+ " WHEN  EI.EI_ExamStatus IN ( ");
		sb_SQLCommand.append(
				TYPE_EXAM_STATUS.STATUS_EXAM_DISABLE.getValue() + " ) THEN " + DISABLE_STATUS + " ELSE 0 END ) ");

		sb_SQLCommand.append("ORDER BY UN.UN_Order,ST.ST_Order ");

		return sb_SQLCommand.toString();
	}

	public void LoadReportResultBySubjectID(List<Integer> ao_subjectIDList) throws SQLException {
		String methodName = "LoadReportResultBySubjectID";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "## Load Report RP002 ##");
		String ls_SQLCommand = GenSQL(ao_subjectIDList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "Query : " + ls_SQLCommand);
		ResultSet lo_Result = DBConn.executeQuery(ls_SQLCommand);
		int RowOrder = 0;
		io_RPRL = new ArrayList<RP002Result>(0);
		RP002Result lo_RPR;
		if (lo_Result.next()) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : Data Found");
			do {
				RowOrder++;
				lo_RPR = new RP002Result();
//			lo_RPR.setSubjectID(lo_Result.getInt("subjectID"));
				String ls_subjectCodeName = lo_Result.getString("subjectCode");
				String ls_subjectName = lo_Result.getString("subjectName");
				if (ls_subjectCodeName == "") {
					ls_subjectCodeName = ls_subjectName;
				} else {
					ls_subjectCodeName += " " + ls_subjectName;
				}
				lo_RPR.setSubjectCodeName(ls_subjectCodeName);
				Integer li_unit = lo_Result.getInt("unit");
				if (li_unit > 0) {
					lo_RPR.setUnit(Converter.Int2Str(li_unit));
				} else {
					lo_RPR.setUnit("");
				}
				Integer li_section = lo_Result.getInt("section");
				if (li_section > 0) {
					lo_RPR.setSection(Converter.Int2Str(li_section));
				} else {
					lo_RPR.setSection("");
				}

				Integer li_examStatus = lo_Result.getInt("examStatus");
				if (li_examStatus == MODIFY_STATUS) {
					lo_RPR.setModifyExamItemNo(lo_Result.getInt("examStatusCount"));
				} else if (li_examStatus == NEW_STATUS) {
					lo_RPR.setNewExamItemNo(lo_Result.getInt("examStatusCount"));
				} else if (li_examStatus == COMPLETE_STATUS) {
					lo_RPR.setCompleteExamItemNo(lo_Result.getInt("examStatusCount"));
				} else if (li_examStatus == DISABLE_STATUS) {
					lo_RPR.setDisableExamItemNo(lo_Result.getInt("examStatusCount"));
				}
				io_RPRL.add(lo_RPR);
			} while (lo_Result.next());
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "Query : Data Not Found");
	}

	public List<RP002Result> CreateRP002ListResult(List<Integer> ao_subjectIDList) throws SQLException {
		String methodName = "CreateRP002ListResult";
		RP002Result lo_RPR;
		this.LoadReportResultBySubjectID(ao_subjectIDList);
		int i;
		if (this.io_RPRL != null) {
			Integer li_size = this.io_RPRL.size();
			
			Integer li_totalExamItemNo;
			
			for (i = 0; i < li_size; i++) {
				lo_RPR = this.io_RPRL.get(i);
				
				li_totalExamItemNo = GetTotalExamItemBySubjectID(lo_RPR.getSubjectID());
				
				Integer li_unitID = lo_RPR.getUnitID();
				Integer li_sectionID = lo_RPR.getSectionID();
				Integer li_subjectID = lo_RPR.getSubjectID();
				lo_RPR.setTotalExamItemNo(li_totalExamItemNo);
//			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : MODIFY_STATUS ");
//			lo_RPR.setModifyExamItemNo(GetNOFExamItemBySectionIDUnitIDExamStatus(li_sectionID,li_unitID,MODIFY_STATUS,TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue()));
//			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : NEW_STATUS ");
//			lo_RPR.setNewExamItemNo(GetNOFExamItemBySectionIDUnitIDExamStatus(li_sectionID,li_unitID,NEW_STATUS,TYPE_EXAM_STATUS.STATUS_EXAM_NEW.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3.getValue(),TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4.getValue()));
//			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : COMPLETE_STATUS");
//			lo_RPR.setCompleteExamItemNo(GetNOFExamItemBySectionIDUnitIDExamStatus(li_sectionID,li_unitID,COMPLETE_STATUS,TYPE_EXAM_STATUS.STATUS_EXAM_READY.getValue()));
//			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName,  "--> Query : DISABLE_STATUS");
//			lo_RPR.setDisableExamItemNo(GetNOFExamItemBySectionIDUnitIDExamStatus(li_sectionID,li_unitID,DISABLE_STATUS,TYPE_EXAM_STATUS.STATUS_EXAM_DISABLE.getValue()));
			}
		}
		return io_RPRL;

	}

   
	public static void main(String[] args) throws ClassNotFoundException, SQLException {
		// TODO Auto-generated method stub
		RP002Generator n = new RP002Generator();
		List<Integer> lo_subjectIDList = new ArrayList();
		lo_subjectIDList.add(69);
		try {
			List<RP002Result> result = n.CreateRP002ListResult(lo_subjectIDList);
			
			System.out.println("Size : " + result.size());
			for (int b = 0; b < result.size(); b++) {
				System.out.println("-----------------------------");
				System.out.println("Row --->: " + (b + 1));
				System.out.println("-----------------------------");
				System.out.print(result.get(b));
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

}
