package esi.ew.report.common;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.PropertyResourceBundle;

public class JDBCUtil {
	private Connection io_DBConn;
	private Statement io_DBStmt;
	private String is_DBLoginName = "sa";
	private String is_DBLoginPassword = "w,jcoj.0";
	private String is_DBURL = "";

	public JDBCUtil() throws ClassNotFoundException, SQLException {
		// this("jdbc:jtds:sqlserver://192.168.199.199:1772;DatabaseName=ADRSEngine", "sa", "w,jcoj.0");
		try {
			PropertyResourceBundle propertyresourcebundle = new PropertyResourceBundle(Thread.currentThread().getContextClassLoader().getResourceAsStream("resources/ExamWHReport.properties"));
			
			is_DBURL = propertyresourcebundle.getString("urldb");
			is_DBLoginName = propertyresourcebundle.getString("userdb");
			is_DBLoginPassword = propertyresourcebundle.getString("passworddb");

		} catch (Exception exception) {
			System.out.println("load Properties File");
			exception.printStackTrace();
		}
		this.openConnection(is_DBURL, is_DBLoginName, is_DBLoginPassword);
	}

	public JDBCUtil(String as_URL, String as_LoginName, String as_LoginPassword) throws ClassNotFoundException, SQLException {
		this.openConnection(as_URL, as_LoginName, as_LoginPassword);
	}

	public void openConnection(String as_URL, String as_LoginName, String as_LoginPassword) throws ClassNotFoundException, SQLException {
		this.is_DBLoginName = as_LoginName;
		this.is_DBLoginPassword = as_LoginPassword;
		this.is_DBURL = as_URL;
		Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
		this.io_DBConn = DriverManager.getConnection(this.is_DBURL, this.is_DBLoginName, this.is_DBLoginPassword);
		this.io_DBConn.setAutoCommit(false);
		this.io_DBStmt = this.io_DBConn.createStatement();
	}

	public void reConnection() throws ClassNotFoundException, SQLException {
		Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
		this.io_DBConn = DriverManager.getConnection(this.is_DBURL, this.is_DBLoginName, this.is_DBLoginPassword);
		this.io_DBConn.setAutoCommit(false);
		this.io_DBStmt = this.io_DBConn.createStatement();
	}

	public Connection getConnection() {
		return (this.io_DBConn);
	}

	public Statement getStatement() {
		return (this.io_DBStmt);
	}

	public ResultSet executeQuery(String strSQL) throws SQLException {
		return (this.io_DBStmt.executeQuery(strSQL));
	}

	public int executeUpdate(String strSQL) throws SQLException {
		return (this.io_DBStmt.executeUpdate(strSQL));
	}

	public void closeConnection() throws SQLException {
		this.io_DBStmt.close();
		this.io_DBConn.close();
	}

	public boolean isClosed() throws SQLException {
		return this.io_DBConn.isClosed();
	}

	public String toString() {
		StringBuffer Temp = new StringBuffer();
		Temp.append("\nDatabase Login Name     : " + is_DBLoginName);
		Temp.append("\nDatabase Login Password : " + is_DBLoginPassword);
		Temp.append("\nDatabase URL            : " + is_DBURL);
		return Temp.toString();
	}
	
	 public static void main(String[] args) throws ClassNotFoundException, SQLException {
		 JDBCUtil JDBCU = new JDBCUtil();
		 
		 System.out.print(JDBCU.toString());
		 
		 
	 }
	
	
}
