package esi.ew.report.service;

import java.io.File;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import esi.ew.report.RP002.RP002Generator;
import esi.ew.report.RP002.RP002Result;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.JRParameter;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

/**
 * Samaporn Ch
 */

public class RP002Service {
	
	private static String ls_className = "RP002Service";
	private static String jrxmlName = "\\RP002.jrxml" ;
	private static String jasperName = "\\RP002.jasper" ;
	
	private static int li_result = 0;
	
	private static JRDataSource createReportDataSource(List<Integer> ao_subjectIDList){
		String methodName = "createReportDataSource";
		JRBeanCollectionDataSource dataSource;
	
		try {
			RP002Generator io_RP002Generator = new RP002Generator();
			List<RP002Result> lo_RP002Result = io_RP002Generator.CreateRP002ListResult(ao_subjectIDList);
			li_result = lo_RP002Result.size();
			for (int b = 0; b < lo_RP002Result.size(); b++) {
				try {
					CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "subjectID size " + ao_subjectIDList.size());
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
//				System.out.println("Row --->: " + (b + 1));
//				System.out.println("-----------------------------");
//				System.out.print(lo_RP002Result.get(b));
			}
			
			Collection reportRows = lo_RP002Result;
			dataSource = new JRBeanCollectionDataSource(reportRows);
			return dataSource;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public static byte [] GetPDFContent(String as_reportTemplatePath,List<Integer> ao_subjectIDList)throws Exception{
		 String methodName = "GetPDFContent";
		 String ls_path = "D:\\My Development AI Projects\\STOU-EW-II Workspace\\EXAM-WAREHOUSE-REPORT-CORE\\jasperReport\\stou-ew-examware";
		 byte [] lb_result = null;
		 if(as_reportTemplatePath != null){
			 ls_path = as_reportTemplatePath;
		 }
		
		JRDataSource dataSource = createReportDataSource(ao_subjectIDList);
		if(li_result!=0){
			
			java.io.ByteArrayOutputStream output = new java.io.ByteArrayOutputStream();
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, ls_className, methodName, "JESPER FILE PATH >>> "+ls_path+jasperName);
			java.io.InputStream reportStream = new java.io.FileInputStream(new File(ls_path+jasperName));
			
			Map Parameters = new HashMap();
			Parameters.put(JRParameter.REPORT_LOCALE, new Locale("th", "TH")); 
			Parameters.put("reportsDirPath",  ls_path);
			Parameters.put("SUBREPORT_DIR",  ls_path);


			JasperRunManager.runReportToPdfStream(reportStream,output, Parameters, dataSource);
			lb_result = output.toByteArray();
//				FO.flush();
			output.close();
		}
		
		return lb_result;
	}
	

	/**
	 * @param args
	 */

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {
			List<Integer> ai_subjectID = new ArrayList();
			ai_subjectID.add(69);

			RP002Service n = new RP002Service();
			byte [] result_GetContent = n.GetPDFContent(null, ai_subjectID);
			java.io.OutputStream FO = new java.io.FileOutputStream("RP002_ID69.pdf"); 
			FO.write(result_GetContent);
			FO.flush();
			FO.close();
			
		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

}
